from util import *
import config
import sys
import gen
from pres_util import *
import recog_domain
import patterns
import specs
import pr

#################### Recognition Results ####################



##            #out.write("<br><a href = Pattern-Diagrams.html#" + patStr + \
##            #         " target = new>pattern information</a><br> \n")
##
##            out.write("<br> <a href = #top> Return to top </a><br> \n")
##            out.write('</td> \
##                         <td><img src = "images/%s.gif" \
##                                  width="470" height="276"> \
##                         </td></tr></table>' % patStr.lower())
##            recogs = [r for r in specs.SPECIFIERS if r.pattern.name ==  patStr]
##            for recog in recogs:
##                key = recog.__name__
##                if not empty(PRGM.pattern_instances[key]):
##                    spec2html(out, recog)
##
##    out.close()

def gen_recog_results_browser ():
    """ creates web-page showing all pattern instances"""
    prgm = get_current_program()
    fileid  = "Pattern-Instances.html"
    fileStr = config.result_file(fileid)
    out = open(fileStr, "w")
    #print "Writing to " + fileStr
    top_of_file(out, "Pattern Instances for " + capitalize_it(prgm.name))
    out.write("</font><a name = top>")
    create_pattern_type_list(out)
    for uid in [p.uid for p in pr.pattern_assertions.values()]:
        out.write('<a href=#' + uid + '>' + uid + '</a> ---')
    for patStr in patterns.PATTERN_TYPES:
        patobj = eval('patterns.' + patStr)
        found = the_pattern_instances(patStr)
        if len(found) > 0:
            out.write("<hr><hr><table><tr><td width = 70%>")
            card_char = "s"
            if len(found) == 1:
                card_char = ""
            out.write("<a name =" + patStr + "> " \
                  + "<h1><font color = 008000>" + patStr + "</font></h1><font size = 3>"\
                      + str(len(found)) + "<b> " + patobj.participants[0] + "</b> participant" +  card_char + \
                      " found </font>")
            objs = [v for v in pr.pattern_assertions.values() \
                    if v.pattern.name == patStr]
            # pattern_assertions used to establish all allow statements
            # pattern instances might contain aggregations
            for obj in objs:
                allow_char = "s"
                if len(obj.evidence) == 1:
                    allow_char = ""
                out.write("<a name =" + obj.uid + "> " \
                      + "<h3><font color = 008000>" + obj.uid + ":" + obj.print_form + \
                          "</font></h3><font size = 3>(covers " + str(len(obj.evidence)) + \
                          " allow path" + allow_char + \
                          " )</font>")
                count = 0
                for e in obj.evidence: # a uid for a PatternR
                    count = count + 1
                    out.write('<br> ----' + str(count) + '.) ')
                    e_obj = pr.all_pattern_realizations[e]
                    participant_roles = patobj.participants
                    for p_role in participant_roles:
                        filler = e_obj.__dict__[p_role]
                        out.write(p_role + ":" + obj2href(filler) + ' <br>')
            out.write('</td> \
                             <td><img src = "images/%s.gif" \
                                      width="470" height="276"> \
                             </td></tr></table>' % patobj.name.lower())
    out.close()
     
def spec2html (out, recog):
    """ out = stream; key = name of recognizer; fileid = prgm-version.html
    creates html table for pattern instances """
    key = recog.__name__
    instances = PRGM.pattern_instances[key]
    out.write("\n<a name = " + key + "> \n" + \
              "<h3>" + key + "</h3>")
    out.write("For pattern " + recog.pattern.name + "\n")
    out.write("<br>Detection level = " + recog.detection + "\n")

    for inst in instances:
       show_instance(out, inst)
    if len(instances) > 0:
        out.write("\n")

def show_instance(out, inst):
    out.write("<br>")
    show_instance_helper(out, inst, 0, 0)

def show_instance_helper(out, accum, level, bqClose):
    if accum == None:
        out.write("<br> Found None")
    if accum.__class__.__name__ == "Aggr":
        for e in accum.elements:
            out.write("<br>" + dashes(level) + obj2href(e.focus) + "<br> \n")
        return
    role = accum.pattern_role
    if role == 'obj':
        role = accum.recognizer.focus_name
    nbr_str = "%d)" % accum.nbr
    color = '500000'
    if level == 0:
        color = '800080'
        if accum.nbr > 1:
            out.write("\n")
        out.write(nbr_str + " \n")
    out.write("<br>" + dashes(level) + obj2href(accum.focus)\
              + " : <font color = " + color + ">" + role + "</font>")
    if (bqClose > 0):
        out.write("\n")
    collabs = accum.with
    if not empty(collabs):
         if level == 0:
            out.write("\n")
         for coll in collabs.keys():
            out.write('<br>' + dashes(level) + "With " + coll + ":\n")
            for c in collabs[coll]:
                show_instance_helper(out, c, level + 4, 1)
            out.write("\n")

def create_pattern_type_list (strm):
    patterns.PATTERN_TYPES.sort()
    strm.write('<center>Number of pattern focii<br>')
    strm.write('<table><tr>')
    count = 0
    for p in patterns.PATTERN_TYPES: 
        nbr = len(the_pattern_instances(p))
        count = count + 1
        if count == 4:
            count = 0
            strm.write('</tr>')
        ref_char = ""
        if nbr == 0:
            ref_char = "!"
        strm.write("<td><" + ref_char + "a href = #" + p + "><font size =1>" + \
                             p + " ( " + str(nbr) \
                             + " )</font></a></td> \n")
    strm.write('</tr></table></center>')

def gen_spec_ptrs ():
    for item in specs.SPECIFIERS:
        ref = item.__name__
        str = ref[5:]
        sys.stdout.write("<a href =#" + ref + "> - " + str + " - </a>")

def gen_security_context_report():
    prgm = get_current_program()
    fileid  = "Security-Context.html"
    fileStr = config.result_file(fileid)
    out = open(fileStr, "w")
    #print "Writing to " + fileStr
    top_of_file(out, "Security Context for " + capitalize_it(prgm.name))
    out.write("Go to <a href=Pattern-Instances.html> Pattern Instances </a> \n")
    out.write("<br>Go to <a href=PolicyHelp.html> Resources </a> \n")
    contexts = seq2set([x.security_context for x in resources_dict.values()])
    for c in contexts:
        if c not in [None, 'DEFAULT']:
            out.write("<a name = " + str(c) + "><h3><font color = ff00ff>" + str(c) + "</font></h3> \n")
            for r in resources_dict.values():
                if r.security_context == c:
                    out.write("<br><a href=PolicyHelp.html#" + r.name + ">" \
                              + r.name \
                              + "</a> \n")
