
##global no_gui
##if not no_gui:
import gtk 

global group_name_map
group_name_map = {}

MAX_WINDOW_Y_SIZE=650

class GroupName:
	
	# Call back function. 
	def enter_callback(self,widget,entry):
                #print 'setting ' + entry.get_name() + ' to ' + entry.get_text() 
                global group_name_map
		entry_text = entry.get_text()
		group_name_map[entry.get_name()] = entry_text
	

	def when_done (self, window):
            global group_name_map
            for e in self.entries:
 		entry_text = e.get_text()
		group_name_map[e.get_name()] = entry_text
            window.destroy()

	def __init__(self, groups):
            return self.init_gui(groups)

	def init_gui(self,groups):
            window=gtk.Window(gtk.WINDOW_TOPLEVEL)
            window.set_title("Set Names for Groups")
            # Set the size of the window.
            self.entries = []
            ysz = 1000
            nbr = len(groups)
	    if 0==nbr:
		    return
            if nbr < 10:
		    ysz = (70 * nbr) + 60
            window.set_size_request(400, min(MAX_WINDOW_Y_SIZE,ysz))
            window.connect("delete_event",gtk.mainquit)
            # Create a  vertical box.
            vbox = gtk.VBox(gtk.FALSE,0)
            window.add(vbox)
            vbox.show()
            for g in groups:
                entry = gtk.Entry()
                entry.set_max_length(50)
                entry.set_name(g)
                # Set the signal handler for activate that calls the callback
                # method. 
                entry.connect("activate",self.enter_callback,entry)
                entry.set_text(g)
                self.entries.append(entry)
                entry.select_region(0,len(entry.get_text()))
                vbox.pack_start(entry, gtk.TRUE, gtk.TRUE,0)
                entry.show()

            # Create a horizontal box.
            hbox = gtk.HBox(gtk.FALSE, 0)
            vbox.add(hbox)
            hbox.show()
            button = gtk.Button("Done")
            button.connect_object("clicked", self.when_done, window)
            vbox.pack_start(button, gtk.TRUE, gtk.TRUE, 0)
            button.set_flags(gtk.CAN_DEFAULT)
            button.grab_default()

            button.show()
            window.show()


def main():
	global no_gui
	if not no_gui: gtk.main()
	return 0

if __name__ == "__main__":
	GroupName(['g1', 'g2', 'g3'])
	main()

